#include <stdio.h>

void rearranjar_heap(int[],int,int);
void construir_heap(int[],int);
void heapsort(int[],int);

int main() {
    int i, A[8]={4,3,2,1,8,7,6,5};
    
    printf("Vetor original: ");
    for (i=0;i<8;i++)
        printf("%d ",A[i]);
    printf("\n");
    
    heapsort(A,8);
        
    printf("\nVetor ordenado: ");    
    for (i=0;i<8;i++)
        printf("%d ",A[i]);
    
    system("pause");
    
    return(0);
}


void rearranjar_heap(int v[], int i, int tamanho_do_heap)
{ 
  int esq, dir, maior, aux; 
  esq=2*i+1; 
  dir=2*i+2; 
  if ((esq<tamanho_do_heap) && (v[esq]>v[i]))
    maior=esq;
  else maior=i; 
  if ((dir<tamanho_do_heap) && (v[dir]>v[maior]))
    maior=dir; 
  if (maior!=i)
  { 
    aux=v[i];
    v[i]=v[maior];
    v[maior]=aux;
    rearranjar_heap(v,maior,tamanho_do_heap); 
  } 
} 

void construir_heap(int v[], int n) 
{ 
  int i;
  for (i=n/2-1; i>=0; i--)
    rearranjar_heap(v,i,n);
} 

void heapsort(int v[], int n) 
{ 
  int i, aux, tamanho_do_heap;
  construir_heap(v,n);
  tamanho_do_heap=n;
  for (i=n-1; i>0; i--) 
  { 
    aux=v[0];
    v[0]=v[i];
    v[i]=aux;
    tamanho_do_heap--; 
    rearranjar_heap(v,0,tamanho_do_heap);
  }
} 
